#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define OP_CLAIM 0
#define OP_RELEASE 1
#define OP_STOP 2

struct ressource
{
    int num_ressource;
    int nb_occurence;
};
typedef struct ressource Ressource;

struct event
{
    int demande;
    int action;
    Ressource R;
};
typedef struct event Event;

struct process
{
    int number;
    int start;
    int priority;
    int nbEvent;
    Event* event;
};
typedef struct process Process;

void fifo(Process* process, int nb_procs, int tempsSwitch)
{
    int horloge=0;
    int horlogeRel=0;
    int nb_proc_restant=nb_procs;
    int i=0;
    int j=0;
    int k=0,p=0;
    int l=0;
    struct process tabProcessActifs[nb_procs];
    while (nb_proc_restant>0)
    {
        for(i=0;i<nb_procs;i++)
        {
            if (horloge==process[i].start)
            {

                tabProcessActifs[j]=process[i];
                if(p==0)
                {
                    printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[j].number);
                }
                j++;
                p++;
                //si il y avait pas de processus actifs

            }
        }
        if(p==0)
        {
            horloge++;
        }
        else
        {
            for(k=0;k<tabProcessActifs[l].nbEvent;k++)
            {
                if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel==tabProcessActifs[l].event[k].demande)
                {
                    printf("Horloge: %dms\n\tR%d +\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                }
                else if(tabProcessActifs[l].event[k].action==OP_RELEASE && horlogeRel==tabProcessActifs[l].event[k].demande)
                {
                    printf("Horloge: %dms\n\tR%d -\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                }
                else if(tabProcessActifs[l].event[k].action==OP_STOP && horlogeRel==tabProcessActifs[l].event[k].demande)
                {
                    printf("Horloge: %dms\n\tP%d ]\n",horloge,tabProcessActifs[l].number);

                    nb_proc_restant--;
                    horlogeRel=0;
                    horloge=horloge+tempsSwitch;
                    p--;
                    if(p>0)
                    {
                        l++;
                        printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[l].number);

                    }
                    if(l==nb_procs)
                        goto fin;

                }
            }
            horloge++;
            horlogeRel++;
        }
    }
    fin :
    printf("\n");
}

void tourniquet(Process* process, int nb_procs, int nbRessource,int occ1, int occ2, int occ3, int tempsSwitch, int quantum)
{
    int horloge=0;
    int nb_proc_restant=nb_procs;
    int i=0,j=0,l=0,k=0,p=0;;
    int compteur=1;
    int nbRessRestant[nbRessource];
    nbRessRestant[1]=occ1;
    nbRessRestant[2]=occ2;
    nbRessRestant[3]=occ3;
    int procFini[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procFini[i]=0;
    }
    int procCommence[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procCommence[i]=0;
    }
    int horlogeRel[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        horlogeRel[i]=0;
    }
    struct process tabProcessActifs[nb_procs];

    while (nb_proc_restant>0)
    {

        for(i=0;i<nb_procs;i++)
        {
            if (horloge==process[i].start)
            {
                tabProcessActifs[j]=process[i];
                procCommence[j]=1;
                j++;
                p++;            //nbr de processus actifs

            }
        }
        if(p==0)            //pas de processus rencontr
        {
            horloge++;
        }

        else                //au moins un processus en cours d'execution
        {
            for(l=0;l<nb_procs;l++) // On alterne de processus  chauqe fin de quantum
            {

                if (procFini[l]==0 && procCommence[l]==1)
                {
                    compteur=0;

                    while(compteur<=quantum)
                    {
                        if(compteur==0)
                        {
                            horloge=horloge+tempsSwitch-1;
                            printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[l].number);
                            procCommence[l]=1;
                        }

                        for(k=0;k<tabProcessActifs[l].nbEvent;k++)          //on scrute le nombre d'venement dans un processus
                            {

                                if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel[l]==tabProcessActifs[l].event[k].demande && nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]==0)
                                {
                                    printf("\t\t\tRessource %d non disponible\n",tabProcessActifs[l].event[k].R.num_ressource);
                                    printf("Horloge: %dms\n\tP%d ]\n",horloge,tabProcessActifs[l].number);
                                    horlogeRel[l]--;
                                    l++;
                                    if(l==nb_procs)
                                    {
                                        l=0;
                                    }
                                    compteur=0;
                                    horloge=horloge+tempsSwitch;
                                    printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[l].number);

                                }
                                else if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel[l]==tabProcessActifs[l].event[k].demande && nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]>0)
                                {
                                    printf("Horloge: %dms\n\tR%d +\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                                    nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]--;
                                }
                                else if(tabProcessActifs[l].event[k].action==OP_RELEASE && horlogeRel[l]==tabProcessActifs[l].event[k].demande)
                                {
                                    printf("Horloge: %dms\n\tR%d -\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                                    nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]++;
                                }
                                else if(tabProcessActifs[l].event[k].action==OP_STOP && horlogeRel[l]==tabProcessActifs[l].event[k].demande)
                                {
                                    p--;
                                    nb_proc_restant--;
                                    procFini[l]=1;
                                    printf("Horloge: %dms\n\tP%d ]\n",horloge,tabProcessActifs[l].number);
                                    printf("FIN DU PROCESSUS %d",tabProcessActifs[l].number);
                                    printf("\t\tNombre de processus restant(s) : %d\n\n",p);
                                    compteur=quantum;
                                }
                            }
                        if(compteur==quantum && procFini[l]==0)
                        {
                            printf("Horloge: %dms\n\tP%d ]\n",horloge,tabProcessActifs[l].number);
                        }
                        horloge++;
                        horlogeRel[l]++;
                        compteur++;

                        for(i=0;i<nb_procs;i++)
                        {
                            if (horloge==process[i].start)
                            {
                                tabProcessActifs[j]=process[i];
                                procCommence[j]=1;
                                j++;
                                p++;
                            }
                        }
                    }
                }
            }
        }
    }
    printf("\n");
}

void preemption(Process* process, int nb_procs, int nbRessource,int occ1, int occ2, int occ3 ,int tempsSwitch)
{
    int horloge=0;
    int nb_proc_restant=nb_procs;
    int i=0,j=0,l=0,k=0,p=0,a,b;
    int nbRessRestant[nbRessource];
    nbRessRestant[1]=occ1;
    nbRessRestant[2]=occ2;
    nbRessRestant[3]=occ3;
    bool procFini[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procFini[i]=false;
    }
    bool procBloque[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procBloque[i]=false;
    }
    bool procCommence[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procCommence[i]=false;
    }
    int horlogeRel[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        horlogeRel[i]=0;
    }
    struct process tabProcessActifs[nb_procs];

    while (nb_proc_restant>0)
    {
        for(i=0;i<nb_procs;i++)
        {
            if (horloge==process[i].start)
            {
                tabProcessActifs[j]=process[i];
                procCommence[j]=1;
                if(p==0)
                {
                    printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[j].number);
                }
                j++;
                p++; //nb de processus en cours

            }
        }
        if(p==0)            //pas de processus rencontr
        {
            horloge++;
        }
        else
        {
            if (procFini[l]==false && procCommence[l]==true)
            {
                for(k=0;k<tabProcessActifs[l].nbEvent;k++)          //on scrute le nombre d'venement dans un processus
                {
                    if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel[l]==tabProcessActifs[l].event[k].demande && nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]==0)
                                {
                                    printf("\t\t\tRessource %d non disponible\n",tabProcessActifs[l].event[k].R.num_ressource);
                                    horlogeRel[l]--;
                                    procBloque[l]=true;

                                }
                    else if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel[l]==tabProcessActifs[l].event[k].demande && nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]>0)
                    {
                        printf("Horloge: %dms\n\tR%d +\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                        nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]--;

                    }
                    else if(tabProcessActifs[l].event[k].action==OP_RELEASE && horlogeRel[l]==tabProcessActifs[l].event[k].demande)
                    {
                        printf("Horloge: %dms\n\tR%d -\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                        for(i=0;i<nb_procs;i++)
                        {
                            procBloque[i]=false;
                        }
                        nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]++;

                    }
                    else if(tabProcessActifs[l].event[k].action==OP_STOP && horlogeRel[l]==tabProcessActifs[l].event[k].demande)
                    {
                        p--;
                        nb_proc_restant--;
                        procFini[l]=true;
                    }
                }

                a=tabProcessActifs[0].priority;
                b=0;

                for(i=1;i<nb_procs;i++)
                {
                    if(tabProcessActifs[i].priority<a && procFini[i]==false && procCommence[i]==true && procBloque[i]==false)
                    {
                        a=tabProcessActifs[i].priority;
                        b=i;
                    }
                }
                if(b!=l)
                {
                    printf("Horloge: %dms\n\tP%d ]\n",horloge,tabProcessActifs[l].number);
                    printf("prio[%d]=%d\n",l,tabProcessActifs[l].priority);
                    horloge=horloge+tempsSwitch;
                    l=b;
                    printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[l].number);
                }
            }
            horloge++;
            horlogeRel[l]++;
        }
    }
    printf("Horloge: %dms\n\tP%d ]\n\n",horloge,tabProcessActifs[l].number);
}

void quantumTempsAge(Process* process, int nb_procs, int nbRessource,int occ1, int occ2, int occ3, int tempsSwitch, int quantum)
{
    int compteur=0;
    int horloge=0;
    int nb_proc_restant=nb_procs;
    int i=0,j=0,l=0,k=0,p=0,a,b;
    int nbRessRestant[nbRessource];
    nbRessRestant[1]=occ1;
    nbRessRestant[2]=occ2;
    nbRessRestant[3]=occ3;
    bool procFini[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procFini[i]=false;
    }
    bool procBloque[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procBloque[i]=false;
    }
    bool procCommence[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        procCommence[i]=false;
    }
    int horlogeRel[nb_procs];
    for(i=0;i<nb_procs;i++)
    {
        horlogeRel[i]=0;
    }
    struct process tabProcessActifs[nb_procs];

    while (nb_proc_restant>0)
    {
        for(i=0;i<nb_procs;i++)
        {
            if (horloge==process[i].start)
            {
                tabProcessActifs[j]=process[i];
                procCommence[j]=true;
                if(p==0)
                {
                    printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[j].number);
                }
                j++;
                p++; //nb de processus en cours

            }
        }
        if(p==0)            //pas de processus rencontr
        {
            horloge++;
        }

        else
        {
            if (procFini[l]==false && procCommence[l]==true)
            {
                for(k=0;k<tabProcessActifs[l].nbEvent;k++)          //on scrute le nombre d'venement dans un processus
                {
                    if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel[l]==tabProcessActifs[l].event[k].demande && nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]==0)
                                {
                                    printf("\t\t\tRessource %d non disponible\n",tabProcessActifs[l].event[k].R.num_ressource);
                                    horlogeRel[l]--;
                                    procBloque[l]=true;

                                }
                    else if(tabProcessActifs[l].event[k].action==OP_CLAIM && horlogeRel[l]==tabProcessActifs[l].event[k].demande && nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]>0)
                    {
                        printf("Horloge: %dms\n\tR%d +\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                        nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]--;

                    }
                    else if(tabProcessActifs[l].event[k].action==OP_RELEASE && horlogeRel[l]==tabProcessActifs[l].event[k].demande)
                    {
                        printf("Horloge: %dms\n\tR%d -\n",horloge,tabProcessActifs[l].event[k].R.num_ressource);
                        for(i=0;i<nb_procs;i++)
                        {
                            procBloque[i]=false;
                        }
                        nbRessRestant[tabProcessActifs[l].event[k].R.num_ressource]++;

                    }
                    else if(tabProcessActifs[l].event[k].action==OP_STOP && horlogeRel[l]==tabProcessActifs[l].event[k].demande)
                    {
                        p--;
                        nb_proc_restant--;
                        procFini[l]=true;
                    }
                }

            }
            if(compteur>=quantum)
                {
                    compteur=0;
                    tabProcessActifs[l].priority++;

                }
                a=tabProcessActifs[0].priority;
                b=0;
            for(i=1;i<nb_procs;i++)
            {
                if(tabProcessActifs[i].priority<a && procFini[i]==false && procCommence[i]==true && procBloque[i]==false)
                {
                    a=tabProcessActifs[i].priority;
                    b=i;
                }
            }
            if(b!=l)
            {
                printf("Horloge: %dms\n\tP%d ]\n",horloge,tabProcessActifs[l].number);
                horloge=horloge+tempsSwitch;
                l=b;
                printf("Horloge: %dms\n\tP%d [\n",horloge,tabProcessActifs[l].number);
            }
            compteur++;
            horloge++;
            horlogeRel[l]++;

        }
    }

    printf("Horloge: %dms\n\tP%d ]\n\n",horloge,tabProcessActifs[l].number);
    for(i=0;i<nb_procs;i++)
    {
        printf("Prio[%d]=%d\n",i,tabProcessActifs[i].priority);
    }
}

int main()
{
    int nbRessource =3;
    Ressource R1;
    R1.num_ressource=1;
    R1.nb_occurence=2;
    Ressource R2;
    R2.num_ressource=2;
    R2.nb_occurence=1;
    Ressource R3;
    R3.num_ressource=3;
    R3.nb_occurence=1;
    int choix=0;
    int nb_procs=5;
    int b=0,a=0;
    struct event p1_events[]={ {5,OP_CLAIM,R1}, {50,OP_RELEASE,R1}, {25,OP_CLAIM,R2}, {45,OP_RELEASE,R2}, {125,OP_STOP} };
    struct event p2_events[]={ {35,OP_CLAIM,R1}, {65,OP_RELEASE,R1}, {5,OP_CLAIM,R2}, {105,OP_RELEASE,R2}, {150,OP_STOP} };
    struct event p3_events[]={ {5,OP_CLAIM,R3}, {70,OP_RELEASE,R3}, {100,OP_STOP} };
    struct event p4_events[]={ {25,OP_CLAIM,R1}, {75,OP_RELEASE,R1}, {30,OP_CLAIM,R3}, {50,OP_RELEASE,R3},{200,OP_STOP} };
    struct event p5_events[]={ {15,OP_CLAIM,R2}, {50,OP_RELEASE,R2}, {65,OP_CLAIM,R2}, {85,OP_RELEASE,R2}, {20,OP_CLAIM,R3}, {50,OP_RELEASE,R3}, {155,OP_STOP} };
    struct process procs[]=
    {
        {.number=1,.start=30,.priority=4,.event=p1_events,.nbEvent=5},
        {.number=2,.start=50,.priority=1,.event=p2_events,.nbEvent=5},
        {.number=3,.start=10,.priority=5,.event=p3_events,.nbEvent=3},
        {.number=4,.start=40,.priority=2,.event=p4_events,.nbEvent=5},
        {.number=5,.start=20,.priority=3,.event=p5_events,.nbEvent=7}
    };

    while(1)
    {
        printf("Algorithme d'ordonnancement ?\n\tFIFO :1\n\tTOURIQUET :2\n\tPRIORITE AVEC PREEMPTION :3\n\tPRIORITE AVEC QUANTUM DE TEMPS ET AGE :4\n\tQUITTER :5\n");
        scanf("%d",&choix);
        switch (choix)
        {
        case 1:
            printf("Choisir le temps pour changer de processus\n\tTEMPS DE SWITCH (entre 1 et 5ms):\t");
            scanf("%d",&b);
            while (b<1 || b>5)
            {
                printf("\n Valeur non conforme, doit etre entre 1 et 5ms\t");
                scanf("%d",&b);
            }
            fifo(procs,nb_procs,b);
            break;

        case 2:

            printf("Choisir le quantum de temps et le temps pour changer de processus\n\tQUANTUM (>5ms) :\t");
            scanf("%d",&a);
            while (a<=5)
            {
                printf("\n Valeur non conforme, doit etre >5ms\t");
                scanf("%d",&a);
            }
            printf("\nTEMPS DE SWITCH (entre 1 et 5ms) :\t");
            scanf("%d",&b);
            while (b<1 || b>5)
            {
                printf("\n Valeur non conforme, doit etre entre 1 et 5ms\t");
                scanf("%d",&b);
            }

            tourniquet(procs,nb_procs,nbRessource,R1.nb_occurence,R2.nb_occurence,R3.nb_occurence,b,a);
            break;

        case 3:
            printf("Choisir le temps pour changer de processus\n\tTEMPS DE SWITCH (entre 1 et 5ms):\t");
            scanf("%d",&b);
            while (b<1 || b>5)
            {
                printf("\n Valeur non conforme, doit etre entre 1 et 5ms\t");
                scanf("%d",&b);
            }
            preemption(procs,nb_procs,nbRessource,R1.nb_occurence,R2.nb_occurence,R3.nb_occurence,b);
            break;

        case 4:
            printf("Choisir le quantum de temps pour incrementer la priorite et le temps pour changer de processus\n\tQUANTUM (>5ms) :\t");
            scanf("%d",&a);
            while (a<=5)
            {
                printf("\n Valeur non conforme, doit etre >5ms\t");
                scanf("%d",&a);
            }
            printf("\nTEMPS DE SWITCH (entre 1 et 5ms) :\t");
            scanf("%d",&b);
            while (b<1 || b>5)
            {
                printf("\n Valeur non conforme, doit etre entre 1 et 5ms\t");
                scanf("%d",&b);
            }
            quantumTempsAge(procs,nb_procs,nbRessource,R1.nb_occurence,R2.nb_occurence,R3.nb_occurence,b,a);
            break;

        case 5:
            return(0);
            break;

        }

    }

}
